<?php
class WC_Gateway_Confirm{
	function __construct(){
		if(!defined('ABSPATH'))exit;
		$this->CreateTable();
		add_action('admin_menu', array($this, 'AdminMenu'), 1);
		add_action('admin_init', array($this,'register_linepay_settings'));
		add_action('woocommerce_order_status_cancelled',array($this,'linepay_refund'),1,1);
	}

	function AdminMenu(){
		$adminpage = function() {
		    require_once LinePay_DIR.'/templates/line-pay-setting-page.php';
		};
		add_menu_page('LINEPAY 設定', __('LINEPAY 設定'), __('manage_options'), 'line-pay-setting',$adminpage, 'dashicons-admin-generic', 56);
	}

	function register_linepay_settings(){
		register_setting( 'linepay-set', 'testmode');
		register_setting( 'linepay-set', 'channelId');
    	register_setting( 'linepay-set', 'channelSecret');
	}

	function linepay_refund($order_id){
		global $wpdb;
		$sql="SELECT count(*) FROM `{$wpdb->prefix}linepay_order` WHERE order_id = '".$order_id."'";
		$check=$wpdb->get_var($sql);
		if($check>0){
			if(get_option( 'testmode' )==1){
				$sandBox = 'https://sandbox-api-pay.line.me';
			}
			else{
				$sandBox = 'https://api-pay.line.me';
			}

			$sql="SELECT `transaction_id` FROM `{$wpdb->prefix}linepay_order` WHERE order_id = '".$order_id."'";
			$transactionId = $wpdb->get_var($sql);

			$channelId = get_option('channelId');
			$channelSecret = get_option('channelSecret');

			$Nonce = date('c') . uniqid('-');

			$uri = "/v3/payments/".$transactionId."/refund";

			$order = wc_get_order( $order_id );
			
			$postData = array(
				'refundAmount' => $order->get_total()
			);


			$authMacText = $channelSecret . $uri . json_encode($postData) . $Nonce;
			$Authorization = base64_encode(hash_hmac('sha256', $authMacText, $channelSecret, true));

			$header = array(
				'Content-Type: application/json; charset=UTF-8',
				'X-LINE-ChannelId: '.$channelId,
			    'X-LINE-Authorization-Nonce: '.$Nonce,
			    'X-LINE-Authorization: '.$Authorization
			);


			$ch = curl_init($sandBox."/v3/payments/".$transactionId."/refund");
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postData));
			$result = json_decode(curl_exec($ch), true);
			curl_close($ch);


			$returnCode=$result["returnCode"];
			if($returnCode=="0000"){
				$order = wc_get_order($order_id);
				$order->update_status( 'wc-refunded' , __( 'LINE Pay付款', 'wc-gateway-jkopay' ) );

				$sql="UPDATE `{$wpdb->prefix}linepay_order` SET `refund_flag` = 'T' WHERE order_id = '".$order_id."'";
				$wpdb->query($sql);
			}
		}
	}

	function CreateTable(){
		global $wpdb;
		require_once(ABSPATH.'wp-admin/includes/upgrade.php');
		$table_name=$wpdb->prefix.'linepay_order';
		if($wpdb->get_var("SHOW TABLES LIKE '$table_name'")!=$table_name){
			$sql="CREATE TABLE `{$wpdb->prefix}linepay_order` (
			  `order_id` int(11) NOT NULL,
			  `order_code` varchar(100) NOT NULL,
			  `order_desc` varchar(100) NOT NULL,
			  `transaction_id` varchar(20) NOT NULL,
			  `refund_flag` varchar(1) NOT NULL,
			  PRIMARY KEY (`order_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";
			dbDelta($sql);
		}

		$table_name=$wpdb->prefix.'linepay_redirect';
		if($wpdb->get_var("SHOW TABLES LIKE '$table_name'")!=$table_name){
			$sql="CREATE TABLE `{$wpdb->prefix}linepay_redirect` (
			  `order_id` int(11) NOT NULL,
			  `url` varchar(500) NOT NULL,
			  PRIMARY KEY (`order_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";
			dbDelta($sql);
		}
	}
}	
?>