<?php
/**
 * Plugin Name: WooCommerce LINE付款
 * Plugin URI: 
 * Description: LINE金流串接外掛
 * Author: nekoto
 * Version: 1.0.2
 * Text Domain: wc-gateway-linepay
 * Domain Path: /i18n/languages/
 */
 
defined( 'ABSPATH' ) or exit;

if(!defined('LinePay_DIR')){
	define('LinePay_DIR', dirname(__FILE__));
}

define('LinePay_URL', plugin_dir_url(__FILE__));


// Make sure WooCommerce is active
if ( ! in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
	return;
}


/**
 * Add the gateway to WC Available Gateways
 * 
 * @since 1.0.0
 * @param array $gateways all available WC gateways
 * @return array $gateways all WC gateways + offline gateway
 */
function wc_linepay_add_to_gateways( $gateways ) {
	$gateways[] = 'WC_Gateway_Linepay';
	return $gateways;
}
add_filter( 'woocommerce_payment_gateways', 'wc_linepay_add_to_gateways' );


/**
 * Adds plugin page links
 * 
 * @since 1.0.0
 * @param array $links all plugin links
 * @return array $links all plugin links + our custom links (i.e., "Settings")
 */
function wc_linepay_gateway_plugin_links( $links ) {

	$plugin_links = array(
		'<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout&section=linepay_gateway' ) . '">' . __( 'Configure', 'wc-gateway-linepay' ) . '</a>'
	);

	return array_merge( $plugin_links, $links );
}
add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'wc_linepay_gateway_plugin_links' );



add_action( 'plugins_loaded', 'wc_linepay_gateway_init', 11 );
 
function wc_linepay_gateway_init() {
	include LinePay_DIR.'/includes/class_linepay-gateway.php';
	include LinePay_DIR.'/includes/class_linepay-confirm.php';
	$GLOBALS['LinepayConfirm']=new WC_Gateway_Confirm();
	WC_Gateway_Linepay::instance();
}